###############################################################################
#  b_symbol.py: Module for PATTERN MATCH - Base symbol class
#  Copyright (C) 2010 Brno University of Technology, ANT @ FIT
#  Author(s): Vlastimil Kosar <ikosar@fit.vutbr.cz>
###############################################################################
#
#  LICENSE TERMS
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#  3. All advertising materials mentioning features or use of this software
#     or firmware must display the following acknowledgement:
#
#       This product includes software developed by the University of
#       Technology, Faculty of Information Technology, Brno and its
#       contributors.
#
#  4. Neither the name of the Company nor the names of its contributors
#     may be used to endorse or promote products derived from this
#     software without specific prior written permission.
#
#  This software or firmware is provided ``as is'', and any express or implied
#  warranties, including, but not limited to, the implied warranties of
#  merchantability and fitness for a particular purpose are disclaimed.
#  In no event shall the company or contributors be liable for any
#  direct, indirect, incidental, special, exemplary, or consequential
#  damages (including, but not limited to, procurement of substitute
#  goods or services; loss of use, data, or profits; or business
#  interruption) however caused and on any theory of liability, whether
#  in contract, strict liability, or tort (including negligence or
#  otherwise) arising in any way out of the use of this software, even
#  if advised of the possibility of such damage.
#
#  $Id$

class accept_exception(Exception):
    """ Class for raising acception Exceptions. """
    pass

class b_Symbol:
    """A base class to represent a symbol."""
    def __init__(self, new_text, new_id = 0):
        self._id    =  new_id    # Symbol identification value
        self.__text  = new_text; # Symbol text 
 
    def get_text(self):
        """Return symbol description for graph representation."""
        return self.__text;

    def get_id(self):
        """Return symbol identification number."""
        return self._id

    def accept(self, text):
        """Return True/False. If symbol is at the beginning of the text, True value is returned and symbol is removed from the text."""

    def collision(self, set_of_symbols):
        """Return True if two or more symbols from set_of_symbols can be accepted for the same text."""

###############################################################################
# End of File b_symbol.py                                                     #
###############################################################################