###############################################################################
#  gen_lutff_nfa_split_tabel.py: Module for PATTERN MATCH
#  Copyright (C) 2010 Brno University of Technology, ANT @ FIT
#  Author(s): Vlastimil Kosar <ikosar@fit.vutbr.cz>
###############################################################################
#
#  LICENSE TERMS
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#  3. All advertising materials mentioning features or use of this software
#     or firmware must display the following acknowledgement:
#
#       This product includes software developed by the University of
#       Technology, Faculty of Information Technology, Brno and its
#       contributors.
#
#  4. Neither the name of the Company nor the names of its contributors
#     may be used to endorse or promote products derived from this
#     software without specific prior written permission.
#
#  This software or firmware is provided ``as is'', and any express or implied
#  warranties, including, but not limited to, the implied warranties of
#  merchantability and fitness for a particular purpose are disclaimed.
#  In no event shall the company or contributors be liable for any
#  direct, indirect, incidental, special, exemplary, or consequential
#  damages (including, but not limited to, procurement of substitute
#  goods or services; loss of use, data, or profits; or business
#  interruption) however caused and on any theory of liability, whether
#  in contract, strict liability, or tort (including negligence or
#  otherwise) arising in any way out of the use of this software, even
#  if advised of the possibility of such damage.
#
#  $Id$

import commands
import sys
import nfa_split
import msfm_parser
import aux_func

text = str()
textl = "'Pravidla';"

outFile = sys.argv[1]

for i in [2, 3, 4, 8, 16]:
    textl += "'" + str(i) + " LUT';" + "'" + str(i) + " FF';"
text += textl + "\n"

for i in range(2, len(sys.argv)):
    textl = "'" + sys.argv[i] + "';"
    
    ns = nfa_split.nfa_split()
    if aux_func.isPickle(sys.argv[i]) == True:
        ns = ns.load(sys.argv[i])
    else:
        Test0 = msfm_parser.msfm_parser()
        Test0.load_file(sys.argv[i])
        ns.create_by_parser(Test0)
    
    for j in [2, 3, 4, 8, 16]:
        ns.create_det_parts(j)
        data = ns.report_logic()
        textl += str(data[0]) + ";" + str(data[1]) + ";"
    text += textl + "\n"
f = open(outFile + ".csv", "w");
f.write(text)
f.close()
